//
//  SelfieViewController.swift
//  FADModulePhoto
//
//  Created by Juan Carlos Pérez on 1/25/19.
//  Copyright (c) 2019 Juan Carlos Pérez. All rights reserved.
//
//  This file was generated by the Clean Swift Xcode Templates so
//  you can apply clean architecture to your iOS and Mac projects,
//  see http://clean-swift.com
//

import UIKit
import AVKit
import FirebaseMLVision

protocol SelfieDisplayLogic: class
{
    func displayInitialConfigResult(viewModel: Selfie.Config.ViewModel)
    func endInitialConfigResult()
    func generateRandomProofOfLife()
    func displayCameraSession(response: Selfie.Config.ViewModel)
    func startSessionRecognition()
    func startViewSession()
    func displayPhotoPreview(selfie: UIImage)
    func takeSelfieAgain()
    func displaySetupCameraSessionResult(response: Selfie.Config.ViewModel)
    func updateSmileStatus(viewModel: Selfie.SmileDetector.ViewModel )
    func updateBlinkStatus(viewModel: Selfie.BlinkDetector.ViewModel )
    func updateProofIndex()
    func displayProcessBufferToPhoto(viewModel: Selfie.Photo.ViewModel)
}

class SelfieViewController: UIViewController, SelfieDisplayLogic, AVCaptureVideoDataOutputSampleBufferDelegate
{
    
    @IBOutlet weak var photoFrameView: UIView!
    @IBOutlet weak var photoF1: UIView!
    @IBOutlet weak var photoF2: UIView!
    @IBOutlet weak var photoF3: UIView!
    @IBOutlet weak var photoF4: UIView!
    @IBOutlet weak var photoF5: UIView!
    @IBOutlet weak var photoF6: UIView!
    @IBOutlet weak var photoF7: UIView!
    @IBOutlet weak var photoF8: UIView!
    @IBOutlet weak var blackView: UIView!
    @IBOutlet weak var blackViewTwo: UIView!
    @IBOutlet weak var blackViewThree: UIView!
    @IBOutlet weak var blackViewFour: UIView!
    
    @IBOutlet weak var photoFrameHeight: NSLayoutConstraint!
    @IBOutlet weak var photoFrameWidth: NSLayoutConstraint!
    
    @IBOutlet weak var imgDetectFace: UIImageView!
    @IBOutlet weak var cameraView: UIView!
    
    
    @IBOutlet weak var proofView: UIView!
    
    
    @IBOutlet weak var proofImgOne: UIImageView!
    @IBOutlet weak var proofImgTwo: UIImageView!
    @IBOutlet weak var proofImgThree: UIImageView!
    
    @IBOutlet weak var proofCheckOne: UIImageView!
    @IBOutlet weak var proofCheckTwo: UIImageView!
    @IBOutlet weak var proofCheckThree: UIImageView!
    
    
    @IBOutlet weak var lblProofOne: UILabel!
    @IBOutlet weak var lblProofTwo: UILabel!
    @IBOutlet weak var lblProofThree: UILabel!
    
    
    @IBOutlet weak var viewLineOne: UIView!
    @IBOutlet weak var viewLineTwo: UIView!
    

    var interactor: SelfieBusinessLogic?
    var router: (NSObjectProtocol & SelfieRoutingLogic & SelfieDataPassing)?
    
    var delegate: SelfieInstructionsDisplayLogic?
    var imgPhoto : UIImage?//Foto
    
    /// Video preview Layer
    var previewLayer: AVCaptureVideoPreviewLayer?
    /// Capture Session
    fileprivate var session: AVCaptureSession?
    /// Front Camera Input Device
    fileprivate var frontCameraDevice: AVCaptureDevice?
   
    /// Orientation of the device
    var orientation: UIInterfaceOrientation?
    
    /// VideoOutput
    var videoOutput : AVCaptureVideoDataOutput?
    ///Flag process image
    var canProcessImages = true
    
    var lifeProofArray : [String] = []
    var blink = 0
    var smile = 0
    
    var ciContext = CIContext()
    var glassesTimeStamps : [Double] = []
    
    
    var testFaceView : UIView?
    var timerPhoto : Timer?
    var intTimer = 0.0
    
    var agree = true
    
    var actualState = ""
    var actualStateIndex = 0
    var takePhoto = false
    
    var smilee = "😬"
    var blinke = "👀"
    var checke = "✅"
    
    var circleBorderView : UIView?
    
    var faceDetector : VisionFaceDetector?
    
   
  // MARK: Object lifecycle
  override init(nibName nibNameOrNil: String?, bundle nibBundleOrNil: Bundle?)
  {
    super.init(nibName: nibNameOrNil, bundle: nibBundleOrNil)
    setup()
  }
  
  required init?(coder aDecoder: NSCoder)
  {
    super.init(coder: aDecoder)
    setup()
  }
  
  // MARK: Setup
  
  private func setup()
  {
    let viewController = self
    let interactor = SelfieInteractor()
    let presenter = SelfiePresenter()
    let router = SelfieRouter()
    viewController.interactor = interactor
    viewController.router = router
    interactor.presenter = presenter
    presenter.viewController = viewController
    router.viewController = viewController
    router.dataStore = interactor
  }
  
  // MARK: Routing
  
  override func prepare(for segue: UIStoryboardSegue, sender: Any?)
  {
    if let scene = segue.identifier {
      let selector = NSSelectorFromString("routeTo\(scene)WithSegue:")
      if let router = router, router.responds(to: selector) {
        router.perform(selector, with: segue)
      }
    }
  }
  
  // MARK: View lifecycle
  
  override func viewDidLoad()
  {
    super.viewDidLoad()
    
    orientation = UIApplication.shared.statusBarOrientation
    doInitialConfig()
  }
  
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)
        
        self.previewLayer?.frame = self.view.bounds
        if #available(iOS 11.0, *) {self.setNeedsUpdateOfHomeIndicatorAutoHidden()}
        
        
        if self.imgPhoto != nil{
            var request = Selfie.Config.Request()
            request.camSession = self.session
            interactor?.doTakeSelfieAgain(request: request)
        }
        
        self.setNeedsStatusBarAppearanceUpdate()
    }
    
    override func viewDidAppear(_ animated: Bool) {
        self.converToCircle()
    }
    
    override var preferredStatusBarStyle : UIStatusBarStyle {
        return .lightContent
    }
    
  
    func doInitialConfig(){
        var request = Selfie.Config.Request()
        interactor?.doInitialConfig(request: request)
    }
    
    func displayInitialConfigResult(viewModel: Selfie.Config.ViewModel){
        session = viewModel.camSession
        frontCameraDevice = viewModel.frontCameraDevice
        proofView.isHidden = !viewModel.isProofLifeSelfie
    }
    
    func endInitialConfigResult() {
        
        self.photoF1.isHidden = true
        self.photoF2.isHidden = true
        self.photoF3.isHidden = true
        self.photoF4.isHidden = true
        self.photoF5.isHidden = true
        self.photoF6.isHidden = true
        self.photoF7.isHidden = true
        self.photoF8.isHidden = true
        
        
        viewLineOne.backgroundColor = UIColor(netHex:UIConstants.BYELLOW)
        viewLineTwo.backgroundColor = UIColor(netHex:UIConstants.BYELLOW)
        
        let options = VisionFaceDetectorOptions()
        options.performanceMode = .fast
        options.classificationMode = .all
        let vision = Vision.vision()
        self.faceDetector = vision.faceDetector(options: options)
        
    }
    
    
    func generateRandomProofOfLife() {
        self.generateRandom()
    }
    
    
    func displayCameraSession(response: Selfie.Config.ViewModel) {
        self.session = response.camSession
        self.frontCameraDevice = response.frontCameraDevice
        
        self.setupCameraSession()
    }
    
    
    func startSessionRecognition() {
        self.startRecognition()
    }
    
    func startViewSession() {
        self.viewSession()
    }
    
    
    func displayPhotoPreview(selfie: UIImage) {
         self.imgPhoto = selfie
         showPreview()
    }
    
    
    func takeSelfieAgain() {
        self.imgPhoto = nil
        self.cameraView.isHidden = false
        self.canProcessImages = true
    }
    
    func switchCameraSession(){
        var request = Selfie.Camera.Session()
        request.camSession = self.session
        interactor?.switchCamera(request: request)
    }
    
    func setupCameraSession () {
        var request = Selfie.Camera.Session()
        request.camSession = self.session
        request.frontCameraDevice = self.frontCameraDevice
        request.captureVideoDataOutputSampleBufferDelegate = self
        
        interactor?.setupCameraSession(request: request)
    }
    
    func displaySetupCameraSessionResult(response: Selfie.Config.ViewModel) {
        self.videoOutput = response.videoOutput
    }
    
    func updateSmileStatus(viewModel: Selfie.SmileDetector.ViewModel ){
        self.glassesTimeStamps = viewModel.glassesTimeStamps
        self.smile = viewModel.smileResult
    }
    
    func updateBlinkStatus(viewModel: Selfie.BlinkDetector.ViewModel ){
        self.glassesTimeStamps = viewModel.glassesTimeStamps
        self.blink = viewModel.blinkResult
    }
    
    func updateProofIndex() {
        self.blink = 0
        self.smile = 0
        self.updateProofIndex(index:  self.actualStateIndex)
    }
    
    func displayProcessBufferToPhoto(viewModel: Selfie.Photo.ViewModel) {
        if viewModel.success{
            DispatchQueue.main.async {
                self.canProcessImages = false
                
                if self.timerPhoto == nil{
                    self.intTimer = viewModel.timeToTakeSelfie
                    self.timerPhoto = Timer.scheduledTimer(timeInterval: self.intTimer, target: self, selector: #selector(SelfieViewController.showPreview), userInfo: nil, repeats: false)
                    self.imgPhoto = viewModel.imgPhoto
                    
                }
            }
        }
    }
    
    
    /// Setup the preview video layer
    func viewSession () {
        previewLayer = AVCaptureVideoPreviewLayer(session: session!)
        previewLayer?.frame = CGRect(x: 0, y: 0, width: self.view.frame.size.width, height: self.view.frame.size.height - 60)
        previewLayer?.videoGravity = AVLayerVideoGravity(rawValue: convertFromAVLayerVideoGravity(AVLayerVideoGravity.resizeAspectFill))
        previewLayer?.backgroundColor = UIColor.black.cgColor
        
        if orientation == UIInterfaceOrientation.landscapeLeft {
            previewLayer?.connection?.videoOrientation = .landscapeLeft

        }else{
            if orientation == UIInterfaceOrientation.landscapeRight {
                previewLayer?.connection?.videoOrientation = .landscapeRight
            }
        }
        
        cameraView.layer.addSublayer(previewLayer!)
        photoFrameView.layer.zPosition = 100
        blackView.layer.zPosition = 100
        blackViewTwo.layer.zPosition = 100
        blackViewThree.layer.zPosition = 100
        blackViewFour.layer.zPosition = 100
        proofView.layer.zPosition = 100
    }
    
    
    /// Start the session
    func startRecognition() {
        
        var request = Selfie.Config.Request()
        request.camSession = self.session
        interactor?.startRecognition(request: request)
        
        self.imgDetectFace.image = Utils.getImageInBundle(image: "face_non_detected-icon", viewController: self)
        
        testFaceView = UIView()
        testFaceView?.backgroundColor = UIColor.red
        self.cameraView.addSubview(testFaceView!)
        testFaceView?.layer.zPosition = 200
        
        let model = UIDevice.current.modelName
        let constantPlus = CGFloat(UIDevice.current.userInterfaceIdiom == .pad ? 200 : 0)
        if model.range(of: "Plus") != nil || UIDevice.haveNotch {
            photoFrameWidth.constant = 320 + constantPlus
            photoFrameHeight.constant = 320 + constantPlus
        }else{
            photoFrameWidth.constant = 300 + constantPlus
            photoFrameHeight.constant = 300 + constantPlus
        }
        
        photoFrameView.layer.cornerRadius = 0.5
    }
    
    /// Stop the session
    func stopRecognition () {
        var request = Selfie.Config.Request()
        request.camSession = self.session
        interactor?.stopRecognition(request: request)
    }
    
    
    func generateRandom () {
        lifeProofArray.removeAll()
        proofCheckOne.isHidden = true
        proofCheckTwo.isHidden = true
        proofCheckThree.isHidden = true
        
        for i in 0..<3{
            lifeProofArray.append(getItemFromInt(type: Int(arc4random_uniform(2))))
            
            switch i {
            case 0:
                proofImgOne.image = returnImage(stringProof: lifeProofArray[i])
                lblProofOne.text = returnLbl(stringProof: lifeProofArray[i])
                break
                
            case 1:
                proofImgTwo.image = returnImage(stringProof: lifeProofArray[i])
                lblProofTwo.text = returnLbl(stringProof: lifeProofArray[i])
                break
                
            case 2:
                proofImgThree.image = returnImage(stringProof: lifeProofArray[i])
                lblProofThree.text = returnLbl(stringProof: lifeProofArray[i])
                break
                
            default:
                break
            }
        }
        
        //self.lblProof.text = getRandomString()
        getActualState()
        print("State:\(self.actualState)")
        blink = 0
        smile = 0
        
    }
    
    func getItemFromInt (type: Int) -> String{
        switch type {
        case 0:
            return blinke
        case 1:
            return smilee
        default:
            print("")
            return ""
        }
    }
    
    func returnImage (stringProof:String) -> UIImage{
        var img = UIImage()
        
        if stringProof == blinke{
            img = Utils.getImageInBundle(image: "parpadea-on", viewController: self)!
        }else{
            img = Utils.getImageInBundle(image: "sonrie-on", viewController: self)!
        }
        return img
        
    }
    
    func returnLbl (stringProof:String) -> String {
        if stringProof == blinke{
            return "Parpadea"
        }else{
            return "Sonrie"
        }
    }
    
    @objc func showPreview () {
        let newSize = CGSize(width: (self.imgPhoto?.size.width)! / 2, height: (self.imgPhoto?.size.height)! / 2)
        let newImage = self.imgPhoto?.resizeImage(targetSize: newSize)
        Singleton.sharedInstance.imgSelfie = newImage
        //self.imgView.image = uiimg//newImage//uiimg.resizeImage(targetSize: newSize)
        
       
        self.cameraView.isHidden = true
        //self.session?.stopRunning()
        self.stopRecognition()
        
        self.takePhoto = false
        self.timerPhoto?.invalidate()
        self.timerPhoto = nil
        
        if Constants.isSaveProcess{
            updateCheckpoint()
        }
        
        
        //router?.routeToShowPreview(segue: nil)
        
        /*
        if let presenter = presentingViewController as? SelfieInstructionsViewController {
            //presenter.contacts.append(newContact)
            presenter.funcToCall(imgPhoto: self.imgPhoto!)
        }
        dismiss(animated: true, completion: nil)
        */
        
        if let delegate = self.delegate {
            delegate.showSelfiePreview(imgPhoto: self.imgPhoto!)
        }
        dismiss(animated: true, completion: nil)
    }
    
    func updateCheckpoint(){
        let checkPoint : Checkpoint = Checkpoint()
        checkPoint.idTypeProcess = 2
        print("Checkpoint actual \(checkPoint.idTypeProcess)")
        if let aSelfie = Singleton.sharedInstance.imgSelfie {
            checkPoint.imgSelfie = aSelfie.pngData()
        }
        
        //JCPD
        //DBManagerObjective.dbManager().update(checkPoint)
    }
    
    func converToCircle(){
        
        DispatchQueue.main.async {
            
            for view in self.photoFrameView.subviews {
                view.removeFromSuperview()
            }
            
            
            let overlay = self.createOverlay(frame: CGRect(x: 0, y: 0, width: self.photoFrameView.frame.size.width, height: self.photoFrameView.frame.size.height),
                                             xOffset: self.photoFrameView.frame.size.width/2,
                                             yOffset: self.photoFrameView.frame.size.height/2,
                                             radius: self.photoFrameView.frame.size.width/2)
            
            
            self.photoFrameView.addSubview(overlay)
            
            self.circleBorderView = UIView(frame: self.photoFrameView.bounds)
            self.circleBorderView?.backgroundColor = UIColor.clear
            self.circleBorderView?.layer.borderColor = UIColor.clear.cgColor
            self.circleBorderView?.layer.borderWidth = 2
            self.circleBorderView?.layer.cornerRadius = self.photoFrameView.frame.size.width / 2
            self.circleBorderView?.clipsToBounds = true
            self.photoFrameView.addSubview(self.circleBorderView!)
            
        }
        
    }
    
    func createOverlay(frame: CGRect,
                       xOffset: CGFloat,
                       yOffset: CGFloat,
                       radius: CGFloat) -> UIView {
        let overlayView = UIView(frame: frame)
        overlayView.backgroundColor = UIColor.black.withAlphaComponent(0.51)
        
        let path = CGMutablePath()
        path.addArc(center: CGPoint(x: frame.midX, y: frame.midY),
                    radius: radius,
                    startAngle: 0.0,
                    endAngle: 2.0 * .pi,
                    clockwise: false)
        path.addRect(CGRect(origin: .zero, size: overlayView.frame.size))
        
        let maskLayer = CAShapeLayer()
        maskLayer.backgroundColor = UIColor.black.cgColor
        maskLayer.path = path
        maskLayer.fillRule = CAShapeLayerFillRule.evenOdd
        
        overlayView.layer.mask = maskLayer
        overlayView.clipsToBounds = true
        
        return overlayView
    }
    
    
    func showWrongFaceScene(){
        DispatchQueue.main.async {
            self.draw(color: UIColor.red)
        }
    }
    
    func showCorrectFaceScene(){
        DispatchQueue.main.async {
            self.draw(color: UIColor.green)
        }
    }
    
    /// Process every frame that capture de camera
    func captureOutput(_ captureOutput: AVCaptureOutput, didOutput sampleBuffer: CMSampleBuffer, from connection: AVCaptureConnection) {
        self.mlKitFaceDetection(sampleBuffer: sampleBuffer)
    }
    
    
    func mlKitFaceDetection (sampleBuffer: CMSampleBuffer) {
        
        if !takePhoto{
            let imageBuffer = CMSampleBufferGetImageBuffer(sampleBuffer)
            let ciImage = CIImage(cvImageBuffer: imageBuffer!)
            let visionImage = VisionImage(buffer: sampleBuffer)
            
            self.faceDetector?.process(visionImage, completion: { (features, error) in
                guard error == nil, let features = features, !features.isEmpty else {
                    self.showWrongFaceScene()
                    return
                }
                
                
                for face in features {
                    
                    let faceRealBounds = self.getRealBoundsFromFace(face: face, ciImage: ciImage)
                    
                    print("FACE BOUNDS")
                    print(faceRealBounds)
                    
                    if self.photoFrameView.frame.contains(faceRealBounds){
                        
                        self.showCorrectFaceScene()
                        
                        if Constants.isProofLifeSelfie {
                            if self.actualState == "👀"{
                                self.processBlink(face: face)
                            }
                            else if self.actualState == self.smilee{
                                self.processSmile(face: face)
                            }
                            else{
                                
                            }
                        }
                        else{
                            self.takePhoto = true
                        }
                    }
                    else{
                        self.showWrongFaceScene()
                    }
                }
                
            })
        }else{//TakePhoto == true
            if canProcessImages{
               self.takePhotoFromUser(sampleBuffer: sampleBuffer)
            }
        }
        
    }
    
    func getRealBoundsFromFace(face : VisionFace, ciImage: CIImage)->CGRect{
        let imageWidth = ciImage.extent.size.width
        let imageHeight = ciImage.extent.size.height
        let viewWidth = UIScreen.main.bounds.size.width
        let viewHeight = UIScreen.main.bounds.size.height
        let rectangleX = face.frame.origin.x
        let rectangleY = face.frame.origin.y
        let rectangleW = face.frame.size.width
        let rectangleH = face.frame.size.height
        
        let realX = (viewWidth * rectangleX ) / imageWidth
        let realY = (viewHeight * rectangleY ) / imageHeight
        let realWidth = (viewWidth * rectangleW) / imageWidth
        let realHeight = (viewHeight * rectangleH) / imageHeight
        
        let faceRealBounds = CGRect(x: abs((realX + (realWidth))-viewWidth), y: abs((realY + (realHeight))-viewHeight), width: realWidth/1.5 , height: realHeight/1.5)
        
        return faceRealBounds
    }
    
    func processBlink(face : VisionFace){
        let request = Selfie.BlinkDetector.Request(blink: self.blink, face: face, glassesTimeStamps: self.glassesTimeStamps)
        interactor?.processBlink(request: request)
    }

    func processSmile(face : VisionFace){
        let request = Selfie.SmileDetector.Request(smile: self.smile, face: face, glassesTimeStamps: self.glassesTimeStamps)
        interactor?.processSmile(request: request)
    }
    
    func takePhotoFromUser(sampleBuffer: CMSampleBuffer){
        var request = Selfie.Photo.Request()
        request.ciContext = self.ciContext
        request.sampleBuffer = sampleBuffer
       interactor?.takePhotoFromUser(request: request)
    }

    
    func draw (color : UIColor) {
        DispatchQueue.main.async {
            self.circleBorderView?.layer.borderColor = color.cgColor
            if color == UIColor.red{
                self.proofView.isHidden = true
                self.imgDetectFace.image = Utils.getImageInBundle(image: "face_non_detected-icon", viewController: self)
            }else{
                self.proofView.isHidden = !Constants.isProofLifeSelfie
                self.imgDetectFace.image = Utils.getImageInBundle(image: "face_detected-icon", viewController: self)
            }
        }
    }
    
    func updateProofIndex (index : Int){
        lifeProofArray[index] = checke
        
        DispatchQueue.main.async {
            
            switch index {
            case 0:
                self.proofCheckOne.isHidden = false
                break
                
            case 1:
                self.proofCheckTwo.isHidden = false
                break
                
            case 2:
                self.proofCheckThree.isHidden = false
                break
                
            default:
                break
            }
            
            //self.lblProof.text = self.getRandomString()
            self.getActualState()
            print("State:\(self.actualState)")
            self.blink = 0
            self.smile = 0
            
            if index + 1 == self.lifeProofArray.count{
                self.takePhoto = true
            }
        }
        
    }
    
    func getActualState(){
        for i in 0..<3{
            if lifeProofArray[i] == blinke || lifeProofArray[i] == smilee{
                actualState = lifeProofArray[i]
                actualStateIndex = i
                break
            }
        }
        
    }
    
    
    @IBAction func btnCancel(_ sender: Any) {
        /*
        let texts = ["title":"alertTitle".localized, "message":"cancelMessage".localized, "button":"accept".localized]
        UIUtils.showAlertTwo(texts: texts, view: self, resultFuncCancel: {
            //print("cancel")
        }) {
            FADModulePhoto.initProccessOnCancel!()
        }
         */
        
        self.presentingViewController?.dismiss(animated: true, completion:nil)
    }
    
    
    @IBAction func switchCameraTapped(sender: AnyObject) {
       self.switchCameraSession()
    }
    
    
    
    // MARK : - viewDidLayoutSubviews
 
    private func updatePreviewLayer(layer: AVCaptureConnection, orientation: AVCaptureVideoOrientation) {
        layer.videoOrientation = orientation
        previewLayer?.frame = self.view.bounds
    }
    
    override func viewDidLayoutSubviews() {
        super.viewDidLayoutSubviews()
        
        if let connection =  self.previewLayer?.connection  {
            
            let currentDevice: UIDevice = UIDevice.current
            
            let orientation: UIDeviceOrientation = currentDevice.orientation
            
            let previewLayerConnection : AVCaptureConnection = connection
            
            if previewLayerConnection.isVideoOrientationSupported {
                
                switch (orientation) {
                case .portrait: updatePreviewLayer(layer: previewLayerConnection, orientation: .portrait)
                self.previewLayer?.connection?.videoOrientation = .portrait
                self.videoOutput?.connection(with: AVMediaType(rawValue: convertFromAVMediaType(AVMediaType.video)))?.videoOrientation = .portrait
                self.previewLayer?.frame = self.view.bounds
                    break
                    
                case .landscapeRight: updatePreviewLayer(layer: previewLayerConnection, orientation: .landscapeLeft)
                self.previewLayer?.connection?.videoOrientation = .landscapeLeft
                self.videoOutput?.connection(with: AVMediaType(rawValue: convertFromAVMediaType(AVMediaType.video)))?.videoOrientation = .landscapeLeft
                self.previewLayer?.frame = self.view.bounds
                    break
                    
                case .landscapeLeft: updatePreviewLayer(layer: previewLayerConnection, orientation: .landscapeRight)
                self.previewLayer?.connection?.videoOrientation = .landscapeRight
                self.videoOutput?.connection(with: AVMediaType(rawValue: convertFromAVMediaType(AVMediaType.video)))?.videoOrientation = .landscapeRight
                self.previewLayer?.frame = self.view.bounds
                    break
                    
                case .portraitUpsideDown: updatePreviewLayer(layer: previewLayerConnection, orientation: .portraitUpsideDown)
                self.previewLayer?.connection?.videoOrientation = .portraitUpsideDown
                self.videoOutput?.connection(with: AVMediaType(rawValue: convertFromAVMediaType(AVMediaType.video)))?.videoOrientation = .portraitUpsideDown
                self.previewLayer?.frame = self.view.bounds
                    break
                    
                default: updatePreviewLayer(layer: previewLayerConnection, orientation: .portrait)
                self.previewLayer?.connection?.videoOrientation = .portrait
                self.videoOutput?.connection(with: AVMediaType(rawValue: convertFromAVMediaType(AVMediaType.video)))?.videoOrientation = .portrait
                self.previewLayer?.frame = self.view.bounds
                    break
                }
            }
        }
    }
    
    
}

// Helper function inserted by Swift 4.2 migrator.
fileprivate func convertFromAVLayerVideoGravity(_ input: AVLayerVideoGravity) -> String {
	return input.rawValue
}

// Helper function inserted by Swift 4.2 migrator.
fileprivate func convertFromAVMediaType(_ input: AVMediaType) -> String {
	return input.rawValue
}
